%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS fact_types.ql,v 1.8 1993/12/10 02:23:13 marku Exp


/*
**  This table lists the clauses that the prover wants saved in theory files
*/

saved_fact(status/1).
saved_fact(equivalence/1). 
saved_fact(preorder/1). 
saved_fact(reverse_of/2). 
saved_fact(stronger_than/2).
saved_fact(axiom/2).	    
saved_fact(theorem/2).     
saved_fact(compiled_rule/8).
saved_fact(compiled_rulez/2).
saved_fact(openrule/8).
saved_fact(tactic_file/1).
saved_fact(save_clauses/3).
saved_fact(F) :-
	theory_saved_fact : [F].

/*
** Save in the global file
*/

global_fact(ancestor/2).
global_fact(parent/2).
global_fact(incompatible_theories/2).
global_fact(theory_saved_fact/1).
global_fact(theory_local_fact/1).
global_fact(extra_global_fact/1).
global_fact(tactic_file/1).
global_fact(symbol/4).
global_fact(interactive_tactic/1).
global_fact(path/1).
global_fact(F) :-
	extra_global_fact : [F].

/*
** Those not saved, but associated with a theory at run-time:
*/

local_fact(lemma/2).
local_fact(F) :-
	theory_local_fact : [F].


/*
** All the 'colon' facts
*/

theory_fact(F) :- saved_fact(F).
theory_fact(F) :- local_fact(F).


theory_extra_fact(F) :- theory_local_fact : [F].
theory_extra_fact(F) :- theory_saved_fact : [F].


/*
** Declare new managed fact types
*/

new_global_fact(F/N) :-
        check_or_writelist(
                \+  global_fact(F/N),
                [(F/N), ' is already in use.']),
        assert_global(extra_global_fact, [F/N]).

new_local_fact(F/N) :-
	check_or_writelist(
		\+  theory_fact(F/N),
		[(F/N), ' is already in use.']),
        assert_global(theory_local_fact, [F/N]).

new_saved_fact(F/N) :-
        check_or_writelist(
                \+  theory_fact(F/N),
                [(F/N), ' is already in use.']),
        assert_global(theory_saved_fact, [F/N]).



