%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS arith.ql,v 1.5 1993/12/10 02:23:30 marku Exp


?- op(930,xfx,evals).
?- op(520,xfx,is_lt).
?- op(520,xfx,is_le).

/*
**  Decision procedures for integer arithmetic not involving variables
*/

X evals Y :- once(( var(Y) ; integer(Y) )), !, X = Y.
X evals Y :- '$evals'(Y, X).

'$evals'(succ(A),      X) :- !, '$evals'((A + 1), X).
'$evals'(pred(A),      X) :- !, '$evals'((A - 1), X).
'$evals'('-'(Y),       X) :- !, Y2 evals Y, '$minus1'(Y2, X).
'$evals'('+'(Y, Z),    X) :- !, Y2 evals Y, Z2 evals Z, '$plus'(Y2, Z2, X).
'$evals'('*'(Y, Z),    X) :- !, Y2 evals Y, Z2 evals Z, '$times'(Y2, Z2, X).
'$evals'('/'(Y, Z),    X) :- !, Y2 evals Y, Z2 evals Z, '$divide'(Y2, Z2, X).
'$evals'(mod(Y, Z),    X) :- !, Y2 evals Y, Z2 evals Z, '$mod'(Y2, Z2, X).
'$evals'('**'(Y, Z),   X) :- !, Y2 evals Y, Z2 evals Z, '$power'(Y2, Z2, X).
'$evals'(bitand(Y, Z), X) :- !, Y2 evals Y, Z2 evals Z, '$bitwise_and'(Y2, Z2, X).
'$evals'(bitor(Y, Z),  X) :- !, Y2 evals Y, Z2 evals Z, '$bitwise_or'(Y2, Z2, X).
'$evals'('<<'(Y, Z),   X) :- !, Y2 evals Y, Z2 evals Z, '$shift_left'(Y2, Z2, X).
'$evals'('>>'(Y, Z),   X) :- !, Y2 evals Y, Z2 evals Z, '$shift_right'(Y2, Z2, X).

M is_lt N :- M2 evals M, N2 evals N, '$less_than'(M2, N2).

M is_le N :- M is_lt N, !.
M is_le N :- M2 evals M, N2 evals N, M2 == N2.


