%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS macros.ql,v 1.5 1993/12/10 02:23:36 marku Exp


initialize_macros :-
	assert(macro_stack([])).

macro(File) :-
    error('Opening Macrofile: '),
    errorln(File),
    open(File, read, Promac),
    retract(macro_stack(Macr)),
    assert(macro_stack([Promac|Macr])),
    see(Promac).


exit_macro :-
    retract(macro_stack([Promac|Macr])),
    close(Promac),
    errorln('Exiting Macrofile.'),
    (Macr = [Macro|Rest] ->
	(see(Macro),
         assert(macro_stack(Macr)))
    ;
	(see(user_input),
	 assert(macro_stack([])))
    ).


in_macro :- macro_stack([_|_]).


