add_theory(fun).
inherit_theory(r).

constant '?'.
constant id.
function 200 rightassoc ';'(_,_).

function is_abs(A)  === (all x x \= ? => x;A = A).
function nec(A)     === (all x x \= ? => x;A).

function 850 nonassoc subject_to(A,B) === if(B, A, ?).

/* Choice Quantifiers.
** ===================
** NB. To turn the def'(_)' names into real definitions, you have
**     to edit fun.dyl.
*/

quantifier(sm).

quantifier(pre_some_i).

axiom 'def(pre_some_i)'
=== (pre_some_i x A)
    = (sm x (ex x (all y y = x => [y/x]*A))
       => (all y y = x => [y/x]*A))
    :- y not_free_in A.

quantifier(some_i).
axiom 'def(some_i)'
=== if(ex x (all y y = x => [y/x]*A),
        (pre_some_i x A),
	?)
    :- y not_free_in A.



mkaxiom(smax, (ex x_1 nec(A)) => [(sm x_1 A)/x_1]*A).
mkaxiom(smbad, (ex x_1 not nec(A)) => (sm x_1 A) = ?).
mkaxiom(smsub, (all x_1 nec(A <=> B)) => nec((sm x_1 A) = (sm x_1 B))).
mkaxiom(substitutivity, nec(A = B) => nec([A/x_1]*C = [B/x_1]*C)).
mkaxiom(allsub, (all x_1 nec(A = B)) => nec((all x_1 A) = (all x_1 B))).
mkaxiom(iflocal, A ; if(B, C, D) = if(A ; B, A ; C, A ; D)).
mkaxiom(alllocal, A ; (all x_1 B) <=> (all x_1 A ; B), x_1 not_free_in A).
mkaxiom(eqllocal_pre, not A = ? and A ; B = A ; C => A ; (B = C)).
mkaxiom(implocal_pre, not A = ? and (A ; B => A ; C) => A ; (B => C)).
mkaxiom(notlocal_pre, not A = ? and not A ; B => A ; (not B)).
mkaxiom(truegood, not true = ?).
mkaxiom(falsegood, not false = ?).
mkaxiom(exabs, ex x_1 is_abs(x_1) and x_1 = A).
mkaxiom(trueabs, is_abs(true)).
mkaxiom(falseabs, is_abs(false)).
mkaxiom(badabs, is_abs(?)).
mkaxiom(indexedchoice, nec(ex x_1 (all x_2 x_2 = x_1 => [x_2/x_1]*A)) => (ex x_1 nec(A)), x_2 not_free_in A).
mkaxiom(compassoc, (A ; B) ; C = A ; (B ; C)).
mkaxiom(strictness, ? ; A = ?).
mkaxiom(leftid, id ; A = A).
mkaxiom(rightid, A ; id = A).





mkaxiom(mkinstabs, is_abs(A) => (not B = ? => B ; A = A)).
mkaxiom(simpabs, is_abs(A) and not B = ? => B ; A = A).
mkaxiom(necandgood, nec(A) and not B = ? => B ; A).
mkaxiom(seqbad, A ; ? = ?).
mkaxiom(compleftlocal, A = B => A ; C = B ; C).
mkaxiom(notbad, not ?).
mkaxiom(badeqvfalse, ? <=> false).
mkaxiom(idgood, not id = ?).
mkaxiom(compgood, A ; B <=> not A = ? and A ; B).
mkaxiom(truenec, nec(true)).
mkaxiom(necimp, nec(A) => A).
mkaxiom(ifcomp, if(A, B, C) ; D = if(A, B ; D, C ; D)).
mkaxiom(ifgood, (A => not B = ?) and (not A => not C = ?) => not if(A, B, C) = ?).
mkaxiom(localcomp, (is_local x_1 A) => (is_local x_1 A ; B), x_1 not_free_in B).
mkaxiom(localsm, (l_local x_1 A) => (is_local x_1 (sm x_2 A))).
mkaxiom(localsome_i, (l_local x_1 A) => (is_local x_1 (some_i x_2 A))).
mkaxiom(impsubject_to, A => (B subject_to A) = B).
mkaxiom(subject_totrue, (A subject_to true) = A).
mkaxiom(eqllocal_eqv, not A = ? => (A ; (B = C) <=> A ; B = A ; C)).
mkaxiom(implocal_eqv, not A = ? => (A ; (B => C) <=> A ; B => A ; C)).
mkaxiom(notlocal_eqv, not A = ? => (A ; (not B) <=> not A ; B)).
mkaxiom(eqllocal, not A = ? => A ; (B = C) = (A ; B = A ; C)).
mkaxiom(implocal, not A = ? => A ; (B => C) = (A ; B => A ; C)).
mkaxiom(notlocal, not A = ? => A ; (not B) = (not A ; B)).
mkaxiom(andlocal, not A = ? => A ; (B and C) = (A ; B and A ; C)).
mkaxiom(orlocal, not A = ? => A ; (B or C) = (A ; B or A ; C)).
mkaxiom(eqvlocal, not A = ? => A ; (B <=> C) = (A ; B <=> A ; C)).
mkaxiom(compand, A ; (B and C) <=> A ; B and A ; C).
mkaxiom(truth_not_bad, A => not A = ?).
mkaxiom(absandimpnec, is_abs(A) and A => nec(A)).
mkaxiom(alllocaleql, not A = ? => A ; (all x_1 B) = (all x_1 A ; B), x_1 not_free_in A).
mkaxiom(eqllocal_eql, not A = ? => A ; true = true).
mkaxiom(true_imp_good, A => not A = ?).
mkaxiom(rev_strictness, not A ; B = ? => not A = ?).
mkaxiom(neq_local, not A = ? => (not A ; B = ?) = A ; ((not B) = ?) <=> not A = ? => A ; (not B = ?) = A ; ((not B) = ?)).


postulate some_i_good
=== (ex x (all y ((y = x) => [y/x]*T)))
    => [(some_i x T)/x]*T
 :- y not_free_in T.

%% Proposition C.2 (ii)
postulate some_i_bad
=== not (ex x (all y ((y = x) => [y/x]*T)))
    => (some_i x T) = ?
 :- y not_free_in T.

%% Proposition C.3
postulate some_i_false
=== (some_i x false) = ? .

%% Proposition C.4
postulate some_i_lemma
=== (ex x T) and (l_local x T)
    => (ex x (all y ((y = x) => [y/x]*T)))
 :- y not_free_in T.

%% Proposition C.5
postulate some_i_result
=== (ex x T) and (l_local x T)
    => [(some_i x T)/x]*T.


openrule(A subject_to B, [1], [B],
	id,
	[<=> --> <=>, = --> =],
	id).

openrule(A subject_to B, [2], [],
	id,
	[= --> <=>],
	[? --> false, _ --> true]).

openrule(nec(A), [1], [],
	[nec(H) --> nec(H), is_abs(H) --> is_abs(H)],
	[<=> --> <=>],
	id).

openrule(A;B, [1], [],
	id,
	[= --> =],
	[]).

openrule(A;B, [2], [],
	[nec(H) --> nec(H), is_abs(H) --> is_abs(H), A;H --> H],
	[<=> --> <=>, = --> =],
	[A;G --> G]).

openrule(sm x A, [b(x)], [],
	id,
	[= --> <=>],
	[]).

openrule(some_i x A, [b(x)], [],
	id,
	[= --> <=>],
	[]).

% theorem some_i_eq
% === (some_i y y=T) = T.   %% y nfi T.

rerun(fun:some_i_eq).


% theorem abs_substitutivity
% === is_abs(X) and (is_abs(Y) and X = Y) => [X/x]*Z = [Y/x]*Z.

rerun(fun:abs_substitutivity).


%% Simplification rules.
rule_group(standard, trueabs, t).
rule_group(standard, falseabs, t).
rule_group(standard, badabs, t).
rule_group(standard, compassoc, f).
rule_group(standard, strictness, f).
rule_group(standard, seqbad, f).
rule_group(standard, leftid, f).
rule_group(standard, rightid, f).
rule_group(standard, truenec, t).
rule_group(standard, subject_totrue, f).


rule_group(localness, fun:localcomp, r).
rule_group(localness, fun:localsm, r).
rule_group(localness, fun:localsome_i, r).
